package com.googlecode.jpattern.service.transaction;

/**
 * 
 * @author Francesco Cina'
 *
 * 22 Apr 2011
 */
public class DefaultTransactionDefinition extends ATransactionDefinition {

	private ATransactionManager transactionManager;
	private String transactionManagerName = "";
	private final boolean forceReadOnly;
	
	public DefaultTransactionDefinition(boolean forceReadOnly) {
		this.forceReadOnly = forceReadOnly;
	}

	@Override
	public String getTransactionManagerName() {
		return transactionManagerName;
	}

	@Override
	public boolean isForceReadOnly() {
		return forceReadOnly;
	}

	@Override
	protected void setTransactionManager(ITransactionService transactionService) {
		transactionManager = transactionService.getDefaultTransactionManager();
		transactionManagerName = transactionService.getDefaultTransactionManagerName();
	}

	@Override
	protected ATransactionManager getTransactionManager() {
		if (transactionManager==null) {
			transactionManager = new NullTransactionManager();
		}
		return transactionManager;
	}
	
}
