package com.googlecode.jpattern.service.transaction;

/**
 * 
 * @author Francesco Cina'
 *
 * 22 Apr 2011
 */
public class TransactionDefinition extends ATransactionDefinition {

	private ATransactionManager transactionManager;
	private final String transactionManagerName;
	private final boolean forceReadOnly;
	
	public TransactionDefinition(String transactionManagerName, boolean forceReadOnly) {
		this.transactionManagerName = transactionManagerName;
		this.forceReadOnly = forceReadOnly;
	}

	@Override
	public String getTransactionManagerName() {
		return transactionManagerName;
	}

	@Override
	public boolean isForceReadOnly() {
		return forceReadOnly;
	}

	@Override
	protected void setTransactionManager(ITransactionService transactionService) {
		this.transactionManager = transactionService.getTransactionManager(transactionManagerName);
	}

	@Override
	protected ATransactionManager getTransactionManager() {
		if (transactionManager==null) {
			transactionManager = new NullTransactionManager();
		}
		return transactionManager;
	}
	
}
